<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.16"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>SigGen: siggen::MTQueue Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
  $(document).ready(initResizable);
/* @license-end */</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">SigGen
   &#160;<span id="projectnumber">1.0</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.16 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('classsiggen_1_1_m_t_queue.html','');});
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pro-methods">Protected Member Functions</a> &#124;
<a href="classsiggen_1_1_m_t_queue-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">siggen::MTQueue Class Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p>synchronized data passing between producer and consumer threads  
 <a href="classsiggen_1_1_m_t_queue.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="_m_t_queue_8h_source.html">MTQueue.h</a>&gt;</code></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a93ce221a4c3d88f219a8a1e59e53c52f"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classsiggen_1_1_m_t_queue.html#a93ce221a4c3d88f219a8a1e59e53c52f">MTQueue</a> (size_t n, size_t blockSize)</td></tr>
<tr class="memdesc:a93ce221a4c3d88f219a8a1e59e53c52f"><td class="mdescLeft">&#160;</td><td class="mdescRight">creates queue for n blocks with each block of blockSize bytes  <a href="classsiggen_1_1_m_t_queue.html#a93ce221a4c3d88f219a8a1e59e53c52f">More...</a><br /></td></tr>
<tr class="separator:a93ce221a4c3d88f219a8a1e59e53c52f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac47b8a0a7ad4c4334dfed8596aea1651"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classsiggen_1_1_m_t_queue.html#ac47b8a0a7ad4c4334dfed8596aea1651">Enqueue</a> (size_t blockIndex, std::vector&lt; char &gt; &amp;data)</td></tr>
<tr class="memdesc:ac47b8a0a7ad4c4334dfed8596aea1651"><td class="mdescLeft">&#160;</td><td class="mdescRight">enqueues data or waits  <a href="classsiggen_1_1_m_t_queue.html#ac47b8a0a7ad4c4334dfed8596aea1651">More...</a><br /></td></tr>
<tr class="separator:ac47b8a0a7ad4c4334dfed8596aea1651"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab383d104dbf22cb80df5fa826c23573b"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classsiggen_1_1_m_t_queue.html#ab383d104dbf22cb80df5fa826c23573b">Dequeue</a> (size_t &amp;blockIndex, std::vector&lt; char &gt; &amp;data)</td></tr>
<tr class="memdesc:ab383d104dbf22cb80df5fa826c23573b"><td class="mdescLeft">&#160;</td><td class="mdescRight">dequeues data or waits  <a href="classsiggen_1_1_m_t_queue.html#ab383d104dbf22cb80df5fa826c23573b">More...</a><br /></td></tr>
<tr class="separator:ab383d104dbf22cb80df5fa826c23573b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a70fe66d834087214efffe789fb296289"><td class="memItemLeft" align="right" valign="top"><a id="a70fe66d834087214efffe789fb296289"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classsiggen_1_1_m_t_queue.html#a70fe66d834087214efffe789fb296289">Terminate</a> ()</td></tr>
<tr class="memdesc:a70fe66d834087214efffe789fb296289"><td class="mdescLeft">&#160;</td><td class="mdescRight">sets terminate flag and notify waiting thread(s) <br /></td></tr>
<tr class="separator:a70fe66d834087214efffe789fb296289"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pro-methods"></a>
Protected Member Functions</h2></td></tr>
<tr class="memitem:a38afc32fe3ff55fe04547c3766fc7421"><td class="memItemLeft" align="right" valign="top"><a id="a38afc32fe3ff55fe04547c3766fc7421"></a>
bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classsiggen_1_1_m_t_queue.html#a38afc32fe3ff55fe04547c3766fc7421">IsWorkReady</a> () const</td></tr>
<tr class="memdesc:a38afc32fe3ff55fe04547c3766fc7421"><td class="mdescLeft">&#160;</td><td class="mdescRight">queue has at least one item <br /></td></tr>
<tr class="separator:a38afc32fe3ff55fe04547c3766fc7421"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:acd9c2ada8a8557be458702a03fd1348a"><td class="memItemLeft" align="right" valign="top"><a id="acd9c2ada8a8557be458702a03fd1348a"></a>
bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classsiggen_1_1_m_t_queue.html#acd9c2ada8a8557be458702a03fd1348a">IsFull</a> () const</td></tr>
<tr class="memdesc:acd9c2ada8a8557be458702a03fd1348a"><td class="mdescLeft">&#160;</td><td class="mdescRight">queue is full <br /></td></tr>
<tr class="separator:acd9c2ada8a8557be458702a03fd1348a"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>synchronized data passing between producer and consumer threads </p>
<p><a class="el" href="classsiggen_1_1_m_t_queue.html" title="synchronized data passing between producer and consumer threads">MTQueue</a> uses classic mutex and condition variables for synchronization. <a class="el" href="classsiggen_1_1_m_t_queue.html" title="synchronized data passing between producer and consumer threads">MTQueue</a> is pre-allocated to N elements and does not change it's size. </p>

<p class="definition">Definition at line <a class="el" href="_m_t_queue_8h_source.html#l00016">16</a> of file <a class="el" href="_m_t_queue_8h_source.html">MTQueue.h</a>.</p>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a id="a93ce221a4c3d88f219a8a1e59e53c52f"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a93ce221a4c3d88f219a8a1e59e53c52f">&#9670;&nbsp;</a></span>MTQueue()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">siggen::MTQueue::MTQueue </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>n</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>blockSize</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>creates queue for n blocks with each block of blockSize bytes </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">n</td><td>size of the queue to be pre-allocated for </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">blockSize</td><td>size of each individual block of data</td></tr>
  </table>
  </dd>
</dl>
<p>the queue will be preallocated to N items, each with blockSize bytes of data </p>

<p class="definition">Definition at line <a class="el" href="_m_t_queue_8cpp_source.html#l00007">7</a> of file <a class="el" href="_m_t_queue_8cpp_source.html">MTQueue.cpp</a>.</p>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="ab383d104dbf22cb80df5fa826c23573b"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ab383d104dbf22cb80df5fa826c23573b">&#9670;&nbsp;</a></span>Dequeue()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void siggen::MTQueue::Dequeue </td>
          <td>(</td>
          <td class="paramtype">size_t &amp;&#160;</td>
          <td class="paramname"><em>blockIndex</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">std::vector&lt; char &gt; &amp;&#160;</td>
          <td class="paramname"><em>data</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>dequeues data or waits </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[out]</td><td class="paramname">blockIndex</td><td>index of the block of data to be processed </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">data</td><td>data corresponding to the index </td></tr>
  </table>
  </dd>
</dl>

<p class="definition">Definition at line <a class="el" href="_m_t_queue_8cpp_source.html#l00042">42</a> of file <a class="el" href="_m_t_queue_8cpp_source.html">MTQueue.cpp</a>.</p>

</div>
</div>
<a id="ac47b8a0a7ad4c4334dfed8596aea1651"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ac47b8a0a7ad4c4334dfed8596aea1651">&#9670;&nbsp;</a></span>Enqueue()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void siggen::MTQueue::Enqueue </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>blockIndex</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">std::vector&lt; char &gt; &amp;&#160;</td>
          <td class="paramname"><em>data</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>enqueues data or waits </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">blockIndex</td><td>index of the block of data to be processed </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">data</td><td>data corresponding to the index </td></tr>
  </table>
  </dd>
</dl>

<p class="definition">Definition at line <a class="el" href="_m_t_queue_8cpp_source.html#l00018">18</a> of file <a class="el" href="_m_t_queue_8cpp_source.html">MTQueue.cpp</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li>/home/x/siggen/lib/include/<a class="el" href="_m_t_queue_8h_source.html">MTQueue.h</a></li>
<li>/home/x/siggen/lib/src/<a class="el" href="_m_t_queue_8cpp_source.html">MTQueue.cpp</a></li>
</ul>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><b>siggen</b></li><li class="navelem"><a class="el" href="classsiggen_1_1_m_t_queue.html">MTQueue</a></li>
    <li class="footer">Generated by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.16 </li>
  </ul>
</div>
</body>
</html>
